package db

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	"github.com/shopspring/decimal"
	"xorm.io/xorm"
)

// SubsidyWithUserFlowInsert 插入单条数据
func SubsidyWithMonthInsert(session *xorm.Session, SubsidyWithUserFlow *model.SubsidyWithUserMonth) (int, error) {
	var data model.SubsidyWithUserMonth
	session.Where("date=? and uid=?", SubsidyWithUserFlow.Date, SubsidyWithUserFlow.Uid).Get(&data)
	if data.Id == 0 {
		data = model.SubsidyWithUserMonth{
			Uid:  SubsidyWithUserFlow.Uid,
			Date: SubsidyWithUserFlow.Date,
		}
		_, err := session.InsertOne(&data)
		if err != nil {
			return 0, err
		}

	}
	if zhios_order_relate_utils.StrToFloat64(SubsidyWithUserFlow.ConsumeAmount) > 0 {
		userAmountValue := decimal.NewFromFloat(zhios_order_relate_utils.StrToFloat64(data.ConsumeAmount))
		amountValue := decimal.NewFromFloat(zhios_order_relate_utils.StrToFloat64(SubsidyWithUserFlow.ConsumeAmount))
		data.ConsumeAmount = userAmountValue.Add(amountValue).RoundFloor(8).String()
	}
	if zhios_order_relate_utils.StrToFloat64(SubsidyWithUserFlow.ExperienceAmount) > 0 {
		userAmountValue := decimal.NewFromFloat(zhios_order_relate_utils.StrToFloat64(data.ExperienceAmount))
		amountValue := decimal.NewFromFloat(zhios_order_relate_utils.StrToFloat64(SubsidyWithUserFlow.ExperienceAmount))
		data.ExperienceAmount = userAmountValue.Add(amountValue).RoundFloor(8).String()
	}
	if zhios_order_relate_utils.StrToFloat64(SubsidyWithUserFlow.StoreAmount) > 0 {
		userAmountValue := decimal.NewFromFloat(zhios_order_relate_utils.StrToFloat64(data.StoreAmount))
		amountValue := decimal.NewFromFloat(zhios_order_relate_utils.StrToFloat64(SubsidyWithUserFlow.StoreAmount))
		data.StoreAmount = userAmountValue.Add(amountValue).RoundFloor(8).String()
	}
	_, err := session.Where("id=?", data.Id).Cols("consume_amount,experience_amount,store_amount").Update(&data)
	if err != nil {
		return 0, err
	}
	return SubsidyWithUserFlow.Id, nil
}
