package model

import (
	"time"
)

type OneCirclesAvailableGreenEnergyPointsFlow struct {
	Id                                  int64     `json:"id" xorm:"pk autoincr BIGINT(20)"`
	CoinId                              int       `json:"coin_id" xorm:"not null comment('虚拟币id') INT(11)"`
	Direction                           int       `json:"direction" xorm:"not null default 1 comment('方向:1收入 2支出') TINYINT(255)"`
	Kind                                int       `json:"kind" xorm:"not null default 1 comment('种类(1:个人活跃积分兑换 2:结算绿色能量释放 3:签到奖励 4:账户余额兑换 5:绿色能量兑换余额)') TINYINT(1)"`
	Title                               string    `json:"title" xorm:"not null default '' comment('标题') VARCHAR(255)"`
	Amount                              string    `json:"amount" xorm:"not null comment('变更数量') DECIMAL(28,10)"`
	BeforePrice                         string    `json:"before_price" xorm:"not null default 0.0000000000 comment('变更前-价格') DECIMAL(28,10)"`
	AfterPrice                          string    `json:"after_price" xorm:"not null default 0.0000000000 comment('变更后-价格') DECIMAL(28,10)"`
	BeforeEcologicalApplicationValues   string    `json:"before_ecological_application_values" xorm:"not null default 0.0000000000 comment('变更前-生态应用区块币数量') DECIMAL(28,10)"`
	AfterEcologicalApplicationValues    string    `json:"after_ecological_application_values" xorm:"not null default 0.0000000000 comment('变更后-生态应用区块币数量') DECIMAL(28,10)"`
	BeforeTechnicalTeamValues           string    `json:"before_technical_team_values" xorm:"not null default 0.0000000000 comment('变更前-技术团队区块币数量') DECIMAL(28,10)"`
	AfterTechnicalTeamValues            string    `json:"after_technical_team_values" xorm:"not null default 0.0000000000 comment('变更后-技术团队区块币数量') DECIMAL(28,10)"`
	BeforeOperateTeamValues             string    `json:"before_operate_team_values" xorm:"not null default 0.0000000000 comment('变更前-运营团队区块币数量') DECIMAL(28,10)"`
	AfterOperateTeamValues              string    `json:"after_operate_team_values" xorm:"not null default 0.0000000000 comment('变更后-运营团队区块币数量') DECIMAL(28,10)"`
	BeforeActiveGiveawaysValues         string    `json:"before_active_giveaways_values" xorm:"not null default 0.0000000000 comment('变更前-活跃赠送区块币数量') DECIMAL(28,10)"`
	AfterActiveGiveawaysValues          string    `json:"after_active_giveaways_values" xorm:"not null default 0.0000000000 comment('变更后-活跃赠送区块币数量') DECIMAL(28,10)"`
	BeforeOriginalQuantityValues        string    `json:"before_original_quantity_values" xorm:"not null default 0.0000000000 comment('变更前-原始数量区块币数量') DECIMAL(28,10)"`
	AfterOriginalQuantityValues         string    `json:"after_original_quantity_values" xorm:"not null default 0.0000000000 comment('变更后-原始数量区块币数量') DECIMAL(28,10)"`
	BeforeOriginalQuantityFundValues    string    `json:"before_original_quantity_fund_values" xorm:"not null default 0.0000000000 comment('变更前-原始资金值') DECIMAL(28,10)"`
	AfterOriginalQuantityFundValues     string    `json:"after_original_quantity_fund_values" xorm:"not null default 0.0000000000 comment('变更后-原始资金值') DECIMAL(28,10)"`
	BeforeMarketplaceMerchantValues     string    `json:"before_marketplace_merchant_values" xorm:"not null default 0.0000000000 comment('变更前-市商区块币数量') DECIMAL(28,10)"`
	AfterMarketplaceMerchantValues      string    `json:"after_marketplace_merchant_values" xorm:"not null default 0.0000000000 comment('变更后-市商区块币数量') DECIMAL(28,10)"`
	BeforeMarketplaceMerchantFundValues string    `json:"before_marketplace_merchant_fund_values" xorm:"not null default 0.0000000000 comment('变更前-市商资金值') DECIMAL(28,10)"`
	AfterMarketplaceMerchantFundValues  string    `json:"after_marketplace_merchant_fund_values" xorm:"not null default 0.0000000000 comment('变更后-市商资金值') DECIMAL(28,10)"`
	BeforeDevelopmentCommitteeValues    string    `json:"before_development_committee_values" xorm:"not null default 0.0000000000 comment('变更前-发展委员会区块币数量') DECIMAL(28,10)"`
	AfterDevelopmentCommitteeValues     string    `json:"after_development_committee_values" xorm:"not null default 0.0000000000 comment('变更后-发展委员会区块币数量') DECIMAL(28,10)"`
	BeforePublicWelfareAndCharityValues string    `json:"before_public_welfare_and_charity_values" xorm:"not null default 0.0000000000 comment('变更前-公益慈善区块币数量') DECIMAL(28,10)"`
	AfterPublicWelfareAndCharityValues  string    `json:"after_public_welfare_and_charity_values" xorm:"not null default 0.0000000000 comment('变更后-公益慈善区块币数量') DECIMAL(28,10)"`
	BeforeStarLevelDividendsValues      string    `json:"before_star_level_dividends_values" xorm:"not null default 0.0000000000 comment('变更前-星级分红区块币数量') DECIMAL(28,10)"`
	AfterStarLevelDividendsValues       string    `json:"after_star_level_dividends_values" xorm:"not null default 0.0000000000 comment('变更后-星级分红区块币数量') DECIMAL(28,10)"`
	BeforeDestructionQuantityValues     string    `json:"before_destruction_quantity_values" xorm:"not null default 0.0000000000 comment('变更前-销毁区块币数量') DECIMAL(28,10)"`
	AfterDestructionQuantityValues      string    `json:"after_destruction_quantity_values" xorm:"not null default 0.0000000000 comment('变更后-销毁区块币数量') DECIMAL(28,10)"`
	BeforeCommunityDividends            string    `json:"before_community_dividends" xorm:"not null default 0.0000000000 comment('变更前-社区分红区块币数量') DECIMAL(28,10)"`
	AfterCommunityDividends             string    `json:"after_community_dividends" xorm:"not null default 0.0000000000 comment('变更后-社区分红区块币数量') DECIMAL(28,10)"`
	CreateTime                          time.Time `json:"create_time" xorm:"default 'CURRENT_TIMESTAMP' comment('创建时间') DATETIME"`
}
