package model

import (
	"time"
)

type OneCirclesGreenEnergyBasicSetting struct {
	Id                       int       `json:"id" xorm:"not null pk autoincr INT(11)"`
	IsOpen                   int       `json:"is_open" xorm:"not null default 1 comment('是否开启(1:开启 0:关闭)') TINYINT(1)"`
	PersonGreenEnergyCoinId  int       `json:"person_green_energy_coin_id" xorm:"not null default 0 comment('个人绿色能量对应虚拟币id') INT(11)"`
	TeamGreenEnergyCoinId    int       `json:"team_green_energy_coin_id" xorm:"not null default 0 comment('团队绿色能量对应虚拟币id') INT(11)"`
	TotalIssuanceAmount      string    `json:"total_issuance_amount" xorm:"not null comment('总发行量') DECIMAL(28,8)"`
	EcologicalApplication    string    `json:"ecological_application" xorm:"not null comment('生态应用') DECIMAL(28,8)"`
	TotalTechnologyTeam      string    `json:"total_technology_team" xorm:"not null comment('技术团队') DECIMAL(28,8)"`
	TotalOperateTeam         string    `json:"total_operate_team" xorm:"not null comment('运营团队') DECIMAL(28,8)"`
	TotalActiveGiveaways     string    `json:"total_active_giveaways" xorm:"not null comment('活跃赠送') DECIMAL(28,8)"`
	OriginalQuantityNums     string    `json:"original_quantity_nums" xorm:"not null comment('原始数量') DECIMAL(28,8)"`
	InitialPrice             string    `json:"initial_price" xorm:"not null comment('初始价格') DECIMAL(28,8)"`
	NowPrice                 string    `json:"now_price" xorm:"not null comment('当前价格') DECIMAL(28,8)"`
	OriginalFunds            string    `json:"original_funds" xorm:"not null comment('原始资金') DECIMAL(28,8)"`
	MarketplaceMerchantNums  string    `json:"marketplace_merchant_nums" xorm:"not null comment('市商数量') DECIMAL(28,8)"`
	MarketplaceMerchantFunds string    `json:"marketplace_merchant_funds" xorm:"not null comment('市商资金') DECIMAL(28,8)"`
	DevelopmentCommittee     string    `json:"development_committee" xorm:"not null comment('发展委员会') DECIMAL(28,8)"`
	PublicWelfareAndCharity  string    `json:"public_welfare_and_charity" xorm:"not null comment('公益慈善') DECIMAL(28,8)"`
	StarLevelDividends       string    `json:"star_level_dividends" xorm:"not null comment('星级分红') DECIMAL(28,8)"`
	CommunityDividends       string    `json:"community_dividends" xorm:"not null comment('社区分红') DECIMAL(28,8)"`
	DestructionQuantityNums  string    `json:"destruction_quantity_nums" xorm:"not null comment('销毁数量') DECIMAL(28,8)"`
	DestructionSetting       string    `json:"destruction_setting" xorm:"not null comment('销毁设置') TEXT"`
	IsLimitDividend          int       `json:"is_limit_dividend" xorm:"not null default 1 comment('是否限制分红(会员本人不活跃,没有绿色能量分红)') TINYINT(1)"`
	SettlementQuantity       int       `json:"settlement_quantity" xorm:"not null default 0 comment('结算数量(百分比)') INT(11)"`
	SignInReward             string    `json:"sign_in_reward" xorm:"not null comment('签到奖励') TEXT"`
	TeamReward               string    `json:"team_reward" xorm:"not null comment('团队奖励') TEXT"`
	PriceSetting             string    `json:"price_setting" xorm:"not null comment('价格设置') TEXT"`
	WelfareOrdersLimit       string    `json:"welfare_orders_limit" xorm:"not null comment('福利订单抢购条件') TEXT"`
	VipEquitySetting         string    `json:"vip_equity_setting" xorm:"not null comment('会员权益') TEXT"`
	CreateAt                 time.Time `json:"create_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
	UpdateAt                 time.Time `json:"update_at" xorm:"not null default 'CURRENT_TIMESTAMP' DATETIME"`
	IsOpenWelfareOrders      int       `json:"is_open_welfare_orders" xorm:"not null default 0 comment('是否开启福利订单') TINYINT(1)"`
	CommunityDividendsCoinId int       `json:"community_dividends_coin_id" xorm:"not null default 0 comment('社区分红对应虚拟币id') INT(11)"`
}
