package enum

// 奖品类型
type RewardKind int

const (
	RewardKindForEntity RewardKind = iota + 1
	RewardKindForVirtual
)

func (kind RewardKind) String() string {
	switch kind {
	case RewardKindForEntity:
		return "实物商品"
	case RewardKindForVirtual:
		return "虚拟商品"
	default:
		return "未知"
	}
}

type HappyOrchardBasicSettingIsOpen int

const (
	HappyOrchardBasicSettingIsOpenForFalse HappyOrchardBasicSettingIsOpen = iota
	HappyOrchardBasicSettingIsOpenForTrue
)

func (kind HappyOrchardBasicSettingIsOpen) String() string {
	switch kind {
	case HappyOrchardBasicSettingIsOpenForFalse:
		return "未开启"
	case HappyOrchardBasicSettingIsOpenForTrue:
		return "已开启"
	default:
		return "未知"
	}
}

type HappyOrchardUserSeedRecordState int

const (
	HappyOrchardUserSeedRecordStateForPlanting HappyOrchardUserSeedRecordState = iota + 1
	HappyOrchardUserSeedRecordStateForUnclaimed
	HappyOrchardUserSeedRecordStateForReceived
)

func (kind HappyOrchardUserSeedRecordState) String() string {
	switch kind {
	case HappyOrchardUserSeedRecordStateForPlanting:
		return "种植中"
	case HappyOrchardUserSeedRecordStateForUnclaimed:
		return "待领取"
	case HappyOrchardUserSeedRecordStateForReceived:
		return "已领取"
	default:
		return "未知"
	}
}

type HappyOrchardUserAssistanceRecords int32

const (
	HappyOrchardUserAssistanceRecordsForSharingAssistance HappyOrchardUserAssistanceRecords = iota + 1
	HappyOrchardUserAssistanceRecordsForPlayGoldenEggGame
	HappyOrchardUserSeedRecordStateForPlayRaffleGame
)

func (kind HappyOrchardUserAssistanceRecords) String() string {
	switch kind {
	case HappyOrchardUserAssistanceRecordsForSharingAssistance:
		return "分享助力"
	case HappyOrchardUserAssistanceRecordsForPlayGoldenEggGame:
		return "玩金蛋游戏助力"
	case HappyOrchardUserSeedRecordStateForPlayRaffleGame:
		return "玩抽奖游戏助力"
	default:
		return "未知"
	}
}

type DealUserWatersKind string

const (
	DealUserWatersKindForWatering           = "watering"
	DealUserWatersKindForSevenDaysSign      = "seven_days_sign"
	DealUserWatersKindForTimerSign          = "timer_sign"
	DealUserWatersKindForPlaceOrderReward   = "place_order_reward"
	DealUserWatersKindForSharingAssistance  = "sharing_assistance"
	DealUserWatersKindForInvitingNewPlayers = "inviting_new_players"
	DealUserWatersKindForBrowsingInterface  = "browsing_interface"
	DealUserWatersKindForPlayGoldenEggGame  = "play_golden_egg_game"
	DealUserWatersKindForPlayRaffleGame     = "play_raffle_game"
	DealUserWatersKindForUpgradeReward      = "upgrade_reward"
)

func (kind DealUserWatersKind) String() string {
	switch kind {
	case DealUserWatersKindForWatering:
		return "浇水"
	case DealUserWatersKindForSevenDaysSign:
		return "7日签到"
	case DealUserWatersKindForTimerSign:
		return "定时签到"
	case DealUserWatersKindForPlaceOrderReward:
		return "下单奖励"
	case DealUserWatersKindForSharingAssistance:
		return "分享助力奖励"
	case DealUserWatersKindForInvitingNewPlayers:
		return "邀请新玩家奖励"
	case DealUserWatersKindForBrowsingInterface:
		return "浏览界面奖励"
	case DealUserWatersKindForPlayGoldenEggGame:
		return "玩金蛋奖励"
	case DealUserWatersKindForPlayRaffleGame:
		return "玩抽奖游戏奖励"
	case DealUserWatersKindForUpgradeReward:
		return "升级奖励"
	default:
		return "未知"
	}
}
