package micro_applications

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/rule"
	enum2 "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/rule/micro_applications/enum"
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/implement"
	"code.fnuoos.com/go_rely_warehouse/zyos_model.git/src/models"
	"errors"
	"xorm.io/xorm"
)

func HappyOrchardGiveIntegral(session *xorm.Session, records models.HappyOrchardRewardExchangeRecords, masterId string) error {
	//1、判断是否是虚拟商品
	if records.RewardKind != int(enum2.RewardKindForVirtual) {
		return errors.New("兑换奖品类型非虚拟商品")
	}

	//2、获取奖品数据
	db := implement.NewHappyOrchardRewardDb(session.Engine())
	happyOrchardReward, err := db.GetHappyOrchardReward(records.SeedId)
	if err != nil {
		return err
	}

	//3、处理给用户虚拟积分
	err = rule.DealUserCoin(session, md.DealUserCoinReq{
		Kind:         "add",
		Mid:          masterId,
		Title:        md.HappyOrchardGiveIntegral,
		TransferType: md.HappyOrchardGiveIntegralForUserVirtualCoinFlow,
		OrdId:        "",
		CoinId:       happyOrchardReward.CoinId,
		Uid:          records.Uid,
		Amount:       float64(happyOrchardReward.Value),
	})
	if err != nil {
		return err
	}
	return nil
}
