package enum

// 可用绿色能量流水-种类
type OneCirclesAvailableGreenEnergyPointsFlowKind int

const (
	PersonalActivePointRedemption OneCirclesAvailableGreenEnergyPointsFlowKind = iota
	SettlementOfGreenEnergyRelease
	SignInReward
	AccountBalanceExchange
	GreenEnergyExchangeBalance
	TeamActivePointRedemption
	SettlementStarLevelDividends
	MarketplaceMerchantNumsAutoExchangeMarketplaceMerchantFunds
	MarketplaceMerchantFundsAutoExchangeMarketplaceMerchantNums
	CommunityDividends
)

func (kind OneCirclesAvailableGreenEnergyPointsFlowKind) String() string {
	switch kind {
	case PersonalActivePointRedemption:
		return "个人活跃积分兑换"
	case SettlementOfGreenEnergyRelease:
		return "结算绿色能量释放"
	case SignInReward:
		return "签到奖励"
	case AccountBalanceExchange:
		return "账户余额兑换"
	case GreenEnergyExchangeBalance:
		return "兑换账户余额"
	case TeamActivePointRedemption:
		return "团队活跃积分兑换"
	case SettlementStarLevelDividends:
		return "绿色能量分红"
	case MarketplaceMerchantNumsAutoExchangeMarketplaceMerchantFunds:
		return "市商数量自动兑换市商资金"
	case MarketplaceMerchantFundsAutoExchangeMarketplaceMerchantNums:
		return "市商资金自动兑换市商数量"
	case CommunityDividends:
		return "社区分红"
	default:
		return "未知状态"
	}
}
