package one_circles

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/rule"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/rule/one_circles/enum"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"errors"
	"fmt"
	"github.com/shopspring/decimal"
	"time"
	"xorm.io/xorm"
)

// CommunityDividends 社区分红
func CommunityDividends(engine *xorm.Engine, masterId string) (err error) {
	////1、查找 `one_circles_green_energy_basic_setting` 基础设置 && `one_circles_public_platoon_basic_setting` 基础设置
	//oneCirclesGreenEnergyBasicSetting, err := db.OneCirclesGreenEnergyBasicSettingGetOneByParams(engine, map[string]interface{}{
	//	"key":   "is_open",
	//	"value": 1,
	//})
	//if err != nil {
	//	return
	//}

	//2、查找当前是否有待分红的记录 "个人活跃积分"可以自动兑换的用户数据 && "团队活跃积分"可以自动兑换的用户数据
	var m model.OneCirclesCommunityDividends
	has, err := engine.Where("is_over = 0").Get(&m)
	if err != nil {
		fmt.Println("err::::::2222", err.Error())
		return
	}
	if has {
		//3、查找 `one_circles_community_dividends_with_user` 数据
		var list []model.OneCirclesCommunityDividendsWithUser
		err = engine.Where("1 = 1").Find(&list)
		totalValue := decimal.NewFromInt(int64(m.Nums))
		singleValue, _ := totalValue.Div(decimal.NewFromInt(int64(len(list)))).Float64()
		session := engine.NewSession()
		defer func() {
			session.Close()
			if err := recover(); err != nil {

				_ = zhios_order_relate_logx.Error(err)
			}
		}()
		session.Begin()
		now := time.Now()

		for _, v := range list {
			//4、 给相应的用户加上分红权益
			err = rule.DealUserCoin(session, md.DealUserCoinReq{
				Kind:         "add",
				Mid:          masterId,
				Title:        md.OneCirclesCommunityDividends,
				TransferType: md.OneCirclesCommunityDividendsForUserVirtualCoinFlow,
				OrdId:        "",
				CoinId:       m.CoinId,
				Uid:          v.Uid,
				Amount:       singleValue,
			})
			if err != nil {
				_ = session.Rollback()
				fmt.Println("err:::::33333", err)
				return err
			}

			//5、增加 one_circles_community_dividends_with_user_records 记录
			_, err = session.InsertOne(&model.OneCirclesCommunityDividendsWithUserRecords{
				Uid:       v.Uid,
				Value:     zhios_order_relate_utils.Float64ToStr(singleValue),
				RecordsId: m.Id,
				CoinId:    m.CoinId,
				CreateAt:  now.Format("2006-01-02 15:04:05"),
				UpdateAt:  now.Format("2006-01-02 15:04:05"),
			})
			if err != nil {
				_ = session.Rollback()
				fmt.Println("err:::::insert", err)
				return err
			}
		}
		//6、 减少“社区分红”钱包中的值
		totalDividend, _ := totalValue.Float64()
		err = DealAvailableGreenEnergyCoin(session, int(enum.CommunityDividends), totalDividend, 0, enum.CommunityDividends.String(), nil, masterId)
		if err != nil {
			_ = session.Rollback()
			fmt.Println("err:::::444444", err)
			return err
		}

		//7、修改 one_circles_community_dividends 记录
		m.IsOver = 1
		m.PersonsNum = len(list)
		affected, err := session.Where("id=?", m.Id).Cols("is_over", "persons_num").Update(m)
		if err != nil {
			_ = session.Rollback()
			fmt.Println("err:::::5555555", err)
			return err
		}
		if affected == 0 {
			_ = session.Rollback()
			fmt.Println("err:::::6666666", errors.New("更新 one_circles_community_dividends 记录失败"))
			return err
		}

		err = session.Commit()
		if err != nil {
			_ = session.Rollback()
			return errors.New("事务提交失败")
		}
	}
	return
}
