package rule

import (
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/db/model"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/md"
	"code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/svc"
	zhios_order_relate_utils "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils"
	zhios_order_relate_logx "code.fnuoos.com/go_rely_warehouse/zyos_go_order_relate_rule.git/utils/logx"
	"errors"
	"fmt"
	"math"
	"strconv"
	"strings"
	"time"
	"xorm.io/xorm"
)

// BatchGetSmallPublicPlatoonRelateCommission 批量分佣 订单显示
func BatchGetSmallPublicPlatoonRelateCommissionByOrder(engine *xorm.Engine, masterId string, SmallPublicPlatoonRelateCommissionReqList []*md.SmallPublicPlatoonRelateCommissionReq) (map[string]*md.SmallPublicPlatoonRelateCommissionResp, error) {
	resp, err := svc.BatchSmallGetPublicPlatoonRelateCommission(engine, masterId, SmallPublicPlatoonRelateCommissionReqList)
	if err != nil {
		return nil, err
	}
	return resp, nil
}

// CalcSmallPublicPlatoonRelateLaXinReward 计算拉新奖励
func CalcSmallPublicPlatoonRelateLaXinReward(engine *xorm.Engine, masterId string, rewardUid, level int) ([]*md.CalcSmallPublicPlatoonRelateLaXinReward, error) {
	resp, err := svc.CalcSmallPublicPlatoonRelateLaXinReward(engine, masterId, rewardUid, level)
	if err != nil {
		return nil, err
	}
	return resp, nil
}

// AddSmallPublicPlatoonRelateCommission 新增小公排用户关系记录
func AddSmallPublicPlatoonRelateCommission(engine *xorm.Engine, AddSmallPublicPlatoonRelateCommissionReqList []*md.SmallAddPublicPlatoonRelateCommissionReq) (map[string]*model.UserSmallPublicPlatoonRelation, error) {
	var resp = map[string]*model.UserSmallPublicPlatoonRelation{}
	//查找 `user_public_platoon_setting` 基础设置
	userPublicPlatoonSetting, err := db.UserPublicPlatoonSettingGetOneByParams(engine, map[string]interface{}{
		"key":   "is_open",
		"value": 1,
	})
	if err != nil {
		return nil, err
	}
	for _, param := range AddSmallPublicPlatoonRelateCommissionReqList {
		isHasPublicPlatoonUserRelation, err11 := db.UserSmallPublicPlatoonRelationGetOneByParams(engine, map[string]interface{}{
			"key":   "uid",
			"value": param.Uid,
		})
		if err11 != nil {
			return nil, err11
		}
		if isHasPublicPlatoonUserRelation != nil {
			return nil, errors.New("当前用户已加入公排")
		}

		//1、判断是否有推荐人
		if param.RecommendUid != "" {
			//2、有推荐人
			//判断是否有uid为-2 (代表等待新用户填充) 的记录
			userSmallPublicPlatoonRelation, err := db.UserSmallPublicPlatoonRelationGetOneByPid(engine, param.RecommendUid, map[string]interface{}{
				"key":   "uid",
				"value": -1,
			})
			if err != nil {
				return nil, err
			}
			if userSmallPublicPlatoonRelation != nil {
				now := time.Now()
				oldUid := userSmallPublicPlatoonRelation.Uid
				userSmallPublicPlatoonRelation.Uid = zhios_order_relate_utils.StrToInt(param.Uid)
				userSmallPublicPlatoonRelation.RecommendUid = zhios_order_relate_utils.StrToInt(param.RecommendUid)
				userSmallPublicPlatoonRelation.ReturnCommissionNum = 0
				userSmallPublicPlatoonRelation.CreateAt = now
				userSmallPublicPlatoonRelation.UpdateAt = now
				userSmallPublicPlatoonRelation.WaitForSettlementDate = now.AddDate(0, 0, userPublicPlatoonSetting.SettleDay).Format("2006-01-02")
				userSmallPublicPlatoonRelation.JoinAt = now
				updateAffected, err := db.UserSmallPublicPlatoonRelationUpdate(engine.NewSession(), userSmallPublicPlatoonRelation.Id, userSmallPublicPlatoonRelation)
				if err != nil {
					return nil, err
				}
				if updateAffected == 0 {
					err = errors.New("更新 user_public_platoon_relation 记录失败")
					return nil, err
				} else {
					for n := 1; n <= 9; n++ {
						str := "father_uid" + strconv.Itoa(n)
						sql := fmt.Sprintf("UPDATE `user_small_public_platoon_relation` SET %s=%s where %s=%s", str, param.Uid, str, strconv.Itoa(oldUid))
						fmt.Println(">>>>>>>sql>>>>>>>", sql)
						_, err = engine.Exec(sql)
						if err != nil {
							return nil, err
						}
					}
					resp[param.Uid] = userSmallPublicPlatoonRelation
				}
				continue
			}
			res, err := smallPublicPlatoon(engine, zhios_order_relate_utils.StrToInt(param.Uid), zhios_order_relate_utils.StrToInt(param.RecommendUid), *userPublicPlatoonSetting)
			if err != nil {
				return nil, err
			}
			resp[param.Uid] = &res
		}

		//else {
		//	//3、无推荐人
		//
		//	//3.1 判断是否有uid为-1 (代表等待新用户填充) 的记录
		//	userSmallPublicPlatoonRelation, err := db.UserSmallPublicPlatoonRelationFindByEmptyPosition(engine)
		//	if err != nil {
		//		return nil, err
		//	}
		//	if userSmallPublicPlatoonRelation != nil {
		//		userSmallPublicPlatoonRelation.Uid = zhios_order_relate_utils.StrToInt(param.Uid)
		//		updateAffected, err := db.UserSmallPublicPlatoonRelationUpdate(engine.NewSession(), userSmallPublicPlatoonRelation.Id, userSmallPublicPlatoonRelation)
		//		if err != nil {
		//			return nil, err
		//		}
		//		if updateAffected == 0 {
		//			err = errors.New("更新 user_public_platoon_relation 记录失败")
		//			return nil, err
		//		} else {
		//			resp[param.Uid] = userSmallPublicPlatoonRelation
		//		}
		//		continue
		//	}
		//
		//	// 查找当前 user_public_platoon_relation 中 `position` 最大的记录
		//	var m model.UserSmallPublicPlatoonRelation
		//	has, err := engine.Where("recommend_uid = 0").OrderBy("id desc").Get(&m)
		//	if err != nil {
		//		return nil, err
		//	}
		//	if has == false {
		//		return nil, errors.New("查询 user_public_platoon_relation 记录失败")
		//	}
		//
		//	// 查找当前大于 `position` 的所有记录
		//	mlist, err := db.UserSmallPublicPlatoonRelationFindRecommends(engine)
		//	if err != nil {
		//		return nil, err
		//	}
		//	var mapBigUserSmallPublicPlatoonRelations = map[int]interface{}{}
		//	for _, item := range mlist {
		//		mapBigUserSmallPublicPlatoonRelations[item.Position] = true
		//	}
		//
		//	res, err := naturalSmallPublicPlatoon(engine, zhios_order_relate_utils.StrToInt(param.Uid), &m.Position, *userPublicPlatoonSetting, mapBigUserSmallPublicPlatoonRelations)
		//	if err != nil {
		//		return nil, err
		//	}
		//	resp[param.Uid] = &res
		//}
	}
	return resp, nil
}

/*
   公排方法
  TODO 相关公式:
  1: 每个等级的起始值(1+5^0+5^1+5^2+...+5^x-2), 每个等级的结束值(`5^0+5^1+5^2+...+5^x-1)
  2: 根据position查找父级position { (position-1)/5 }
  3: 根据position查找等级level {position-5^0-5^1-5^2-...-5^x 是否 <0 ?  => x+1 }
  4: 根据最新自增`id` 逆向推导 position {levelFirstPosition + (position-1)%5}
*/
func smallPublicPlatoon(engine *xorm.Engine, uid, recommendUid int, userPublicPlatoonSetting model.UserPublicPlatoonSetting) (model.UserSmallPublicPlatoonRelation, error) {
	var standardSmallPublicPlatoonRelation md.StandardSmallPublicPlatoonRelation
	var userSmallPublicPlatoonRelation model.UserSmallPublicPlatoonRelation
	var fatherUid int
	//1、 查找当前 user_small_public_platoon_relation 中 recommendUid 的记录
	m, err := db.UserSmallPublicPlatoonRelationGetOneByParams(engine, map[string]interface{}{
		"key":   "uid",
		"value": recommendUid,
	})
	if err != nil {
		return model.UserSmallPublicPlatoonRelation{}, err
	}
	//if m == nil {
	//	recommendUid = 3
	//	m, err = db.UserSmallPublicPlatoonRelationGetOneByParams(engine, map[string]interface{}{
	//		"key":   "uid",
	//		"value": recommendUid,
	//	})
	//}

	//2、 查找当前 user_small_public_platoon_relation 中 recommendUid 所有的子记录
	userSmallPublicPlatoonRelations, err := db.UserSmallPublicPlatoonRelationFindByPid(engine, m.Uid, "father_uid1", "position1")
	if err != nil {
		return model.UserSmallPublicPlatoonRelation{}, err
	}

	if len(userSmallPublicPlatoonRelations) == 0 {
		fatherUid = m.Uid

		//证明是第一个
		standardSmallPublicPlatoonRelation.FatherUid1 = m.Uid
		standardSmallPublicPlatoonRelation.FatherUid2 = m.FatherUid1
		standardSmallPublicPlatoonRelation.FatherUid3 = m.FatherUid2
		standardSmallPublicPlatoonRelation.FatherUid4 = m.FatherUid3
		standardSmallPublicPlatoonRelation.FatherUid5 = m.FatherUid4
		standardSmallPublicPlatoonRelation.FatherUid6 = m.FatherUid5
		standardSmallPublicPlatoonRelation.FatherUid7 = m.FatherUid6
		standardSmallPublicPlatoonRelation.FatherUid8 = m.FatherUid7
		standardSmallPublicPlatoonRelation.FatherUid9 = m.FatherUid8

		standardSmallPublicPlatoonRelation.Pid1 = m.Position
		standardSmallPublicPlatoonRelation.Pid2 = m.Position1
		standardSmallPublicPlatoonRelation.Pid3 = m.Position2
		standardSmallPublicPlatoonRelation.Pid4 = m.Position3
		standardSmallPublicPlatoonRelation.Pid5 = m.Position4
		standardSmallPublicPlatoonRelation.Pid6 = m.Position5
		standardSmallPublicPlatoonRelation.Pid7 = m.Position6
		standardSmallPublicPlatoonRelation.Pid8 = m.Position7
		standardSmallPublicPlatoonRelation.Pid9 = m.Position8

		standardSmallPublicPlatoonRelation.Position1 = smallSearchPositionFirstSonPosition(m.Position, userPublicPlatoonSetting.SeveralTimes)
		standardSmallPublicPlatoonRelation.Position2 = smallReverseDeductionPositionByFather(m.Position1, m.Level1, userPublicPlatoonSetting.SeveralTimes, 0)
		standardSmallPublicPlatoonRelation.Position3 = smallReverseDeductionPositionByFather(m.Position2, m.Level2, userPublicPlatoonSetting.SeveralTimes, 0)
		standardSmallPublicPlatoonRelation.Position4 = smallReverseDeductionPositionByFather(m.Position3, m.Level3, userPublicPlatoonSetting.SeveralTimes, 0)
		standardSmallPublicPlatoonRelation.Position5 = smallReverseDeductionPositionByFather(m.Position4, m.Level4, userPublicPlatoonSetting.SeveralTimes, 0)
		standardSmallPublicPlatoonRelation.Position6 = smallReverseDeductionPositionByFather(m.Position5, m.Level5, userPublicPlatoonSetting.SeveralTimes, 0)
		standardSmallPublicPlatoonRelation.Position7 = smallReverseDeductionPositionByFather(m.Position6, m.Level6, userPublicPlatoonSetting.SeveralTimes, 0)
		standardSmallPublicPlatoonRelation.Position8 = smallReverseDeductionPositionByFather(m.Position7, m.Level7, userPublicPlatoonSetting.SeveralTimes, 0)
		standardSmallPublicPlatoonRelation.Position9 = smallReverseDeductionPositionByFather(m.Position8, m.Level8, userPublicPlatoonSetting.SeveralTimes, 0)

		if m.Level1 == 0 {
			m.Level1--
		}
		if m.Level2 == 0 {
			m.Level2--
		}
		if m.Level3 == 0 {
			m.Level3--
		}
		if m.Level4 == 0 {
			m.Level4--
		}
		if m.Level5 == 0 {
			m.Level5--
		}
		if m.Level6 == 0 {
			m.Level6--
		}
		if m.Level7 == 0 {
			m.Level7--
		}
		if m.Level8 == 0 {
			m.Level8--
		}
		if m.Level9 == 0 {
			m.Level9--
		}
		standardSmallPublicPlatoonRelation.Level1 = m.Level + 1
		standardSmallPublicPlatoonRelation.Level2 = m.Level1 + 1
		standardSmallPublicPlatoonRelation.Level3 = m.Level2 + 1
		standardSmallPublicPlatoonRelation.Level4 = m.Level3 + 1
		standardSmallPublicPlatoonRelation.Level5 = m.Level4 + 1
		standardSmallPublicPlatoonRelation.Level6 = m.Level5 + 1
		standardSmallPublicPlatoonRelation.Level7 = m.Level6 + 1
		standardSmallPublicPlatoonRelation.Level8 = m.Level7 + 1
		standardSmallPublicPlatoonRelation.Level9 = m.Level8 + 1
		standardSmallPublicPlatoonRelation.LevelTotal = m.LevelTotal + 1
	} else {
		//TODO::判断直属下级是否排满
		if len(userSmallPublicPlatoonRelations) >= userPublicPlatoonSetting.SeveralTimes {
			var fatherLevel float64
			smallMakeSearchLevel(&m.Position, float64(userPublicPlatoonSetting.SeveralTimes), &fatherLevel)
			var times = 0
			data, father, err := smallFindSuitablePosition(engine, &m.Position, float64(userPublicPlatoonSetting.SeveralTimes), m.Uid, int(fatherLevel), &times)
			if err != nil {
				return model.UserSmallPublicPlatoonRelation{}, err
			}
			fatherUid = father
			standardSmallPublicPlatoonRelation = data
		} else {
			fatherUid = m.Uid

			standardSmallPublicPlatoonRelation.FatherUid1 = userSmallPublicPlatoonRelations[0].FatherUid1
			standardSmallPublicPlatoonRelation.FatherUid2 = userSmallPublicPlatoonRelations[0].FatherUid2
			standardSmallPublicPlatoonRelation.FatherUid3 = userSmallPublicPlatoonRelations[0].FatherUid3
			standardSmallPublicPlatoonRelation.FatherUid4 = userSmallPublicPlatoonRelations[0].FatherUid4
			standardSmallPublicPlatoonRelation.FatherUid5 = userSmallPublicPlatoonRelations[0].FatherUid5
			standardSmallPublicPlatoonRelation.FatherUid6 = userSmallPublicPlatoonRelations[0].FatherUid6
			standardSmallPublicPlatoonRelation.FatherUid7 = userSmallPublicPlatoonRelations[0].FatherUid7
			standardSmallPublicPlatoonRelation.FatherUid8 = userSmallPublicPlatoonRelations[0].FatherUid8
			standardSmallPublicPlatoonRelation.FatherUid9 = userSmallPublicPlatoonRelations[0].FatherUid9

			standardSmallPublicPlatoonRelation.Pid1 = userSmallPublicPlatoonRelations[0].Pid1
			standardSmallPublicPlatoonRelation.Pid2 = userSmallPublicPlatoonRelations[0].Pid2
			standardSmallPublicPlatoonRelation.Pid3 = userSmallPublicPlatoonRelations[0].Pid3
			standardSmallPublicPlatoonRelation.Pid4 = userSmallPublicPlatoonRelations[0].Pid4
			standardSmallPublicPlatoonRelation.Pid5 = userSmallPublicPlatoonRelations[0].Pid5
			standardSmallPublicPlatoonRelation.Pid6 = userSmallPublicPlatoonRelations[0].Pid6
			standardSmallPublicPlatoonRelation.Pid7 = userSmallPublicPlatoonRelations[0].Pid7
			standardSmallPublicPlatoonRelation.Pid8 = userSmallPublicPlatoonRelations[0].Pid8
			standardSmallPublicPlatoonRelation.Pid9 = userSmallPublicPlatoonRelations[0].Pid9

			standardSmallPublicPlatoonRelation.Position1 = userSmallPublicPlatoonRelations[0].Position1 + 1
			if userSmallPublicPlatoonRelations[0].Position2 != 0 {
				standardSmallPublicPlatoonRelation.Position2 = userSmallPublicPlatoonRelations[0].Position2 + 1
			}
			if userSmallPublicPlatoonRelations[0].Position3 != 0 {
				standardSmallPublicPlatoonRelation.Position3 = userSmallPublicPlatoonRelations[0].Position3 + 1
			}
			if userSmallPublicPlatoonRelations[0].Position4 != 0 {
				standardSmallPublicPlatoonRelation.Position4 = userSmallPublicPlatoonRelations[0].Position4 + 1
			}
			if userSmallPublicPlatoonRelations[0].Position5 != 0 {
				standardSmallPublicPlatoonRelation.Position5 = userSmallPublicPlatoonRelations[0].Position5 + 1
			}
			if userSmallPublicPlatoonRelations[0].Position6 != 0 {
				standardSmallPublicPlatoonRelation.Position6 = userSmallPublicPlatoonRelations[0].Position6 + 1
			}
			if userSmallPublicPlatoonRelations[0].Position7 != 0 {
				standardSmallPublicPlatoonRelation.Position7 = userSmallPublicPlatoonRelations[0].Position7 + 1
			}
			if userSmallPublicPlatoonRelations[0].Position8 != 0 {
				standardSmallPublicPlatoonRelation.Position8 = userSmallPublicPlatoonRelations[0].Position8 + 1
			}
			if userSmallPublicPlatoonRelations[0].Position9 != 0 {
				standardSmallPublicPlatoonRelation.Position9 = userSmallPublicPlatoonRelations[0].Position9 + 1
			}

			standardSmallPublicPlatoonRelation.Level1 = userSmallPublicPlatoonRelations[0].Level1
			standardSmallPublicPlatoonRelation.Level2 = userSmallPublicPlatoonRelations[0].Level2
			standardSmallPublicPlatoonRelation.Level3 = userSmallPublicPlatoonRelations[0].Level3
			standardSmallPublicPlatoonRelation.Level4 = userSmallPublicPlatoonRelations[0].Level4
			standardSmallPublicPlatoonRelation.Level5 = userSmallPublicPlatoonRelations[0].Level5
			standardSmallPublicPlatoonRelation.Level6 = userSmallPublicPlatoonRelations[0].Level6
			standardSmallPublicPlatoonRelation.Level7 = userSmallPublicPlatoonRelations[0].Level7
			standardSmallPublicPlatoonRelation.Level8 = userSmallPublicPlatoonRelations[0].Level8
			standardSmallPublicPlatoonRelation.Level9 = userSmallPublicPlatoonRelations[0].Level9
			standardSmallPublicPlatoonRelation.LevelTotal = userSmallPublicPlatoonRelations[0].LevelTotal

		}

	}

	//2、查找对应pid的 user_public_platoon_relation 记录
	var m1 model.UserSmallPublicPlatoonRelation
	if has, err := engine.Where("uid=?", fatherUid).Get(&m1); err != nil || has == false {
		return userSmallPublicPlatoonRelation, err
	}
	var fatherUidStr string
	if m1.FatherUid == "" {
		//TODO::顶级
		fatherUidStr = zhios_order_relate_utils.IntToStr(m1.Id)
	} else {
		fatherUids := strings.Split(m1.FatherUid, "-")
		if len(fatherUids) >= userPublicPlatoonSetting.SeveralRows {
			fatherUidStr = zhios_order_relate_utils.IntToStr(m1.Id) + "-" + strings.Join(fatherUids[0:userPublicPlatoonSetting.SeveralRows:len(fatherUids)], "-")
		} else {
			fatherUidStr = zhios_order_relate_utils.IntToStr(m1.Id) + "-" + m1.FatherUid
		}
	}

	if userPublicPlatoonSetting.SettleDay == 0 {
		userPublicPlatoonSetting.SettleDay = 30
	}

	// 3、插入 user_public_platoon_relation 记录
	now := time.Now()
	userSmallPublicPlatoonRelation.Uid = uid
	userSmallPublicPlatoonRelation.FatherUid = fatherUidStr

	userSmallPublicPlatoonRelation.FatherUid1 = standardSmallPublicPlatoonRelation.FatherUid1
	userSmallPublicPlatoonRelation.FatherUid2 = standardSmallPublicPlatoonRelation.FatherUid2
	userSmallPublicPlatoonRelation.FatherUid3 = standardSmallPublicPlatoonRelation.FatherUid3
	userSmallPublicPlatoonRelation.FatherUid4 = standardSmallPublicPlatoonRelation.FatherUid4
	userSmallPublicPlatoonRelation.FatherUid5 = standardSmallPublicPlatoonRelation.FatherUid5
	userSmallPublicPlatoonRelation.FatherUid6 = standardSmallPublicPlatoonRelation.FatherUid6
	userSmallPublicPlatoonRelation.FatherUid7 = standardSmallPublicPlatoonRelation.FatherUid7
	userSmallPublicPlatoonRelation.FatherUid8 = standardSmallPublicPlatoonRelation.FatherUid8
	userSmallPublicPlatoonRelation.FatherUid9 = standardSmallPublicPlatoonRelation.FatherUid9
	userSmallPublicPlatoonRelation.Pid1 = standardSmallPublicPlatoonRelation.Pid1
	userSmallPublicPlatoonRelation.Pid2 = standardSmallPublicPlatoonRelation.Pid2
	userSmallPublicPlatoonRelation.Pid3 = standardSmallPublicPlatoonRelation.Pid3
	userSmallPublicPlatoonRelation.Pid4 = standardSmallPublicPlatoonRelation.Pid4
	userSmallPublicPlatoonRelation.Pid5 = standardSmallPublicPlatoonRelation.Pid5
	userSmallPublicPlatoonRelation.Pid6 = standardSmallPublicPlatoonRelation.Pid6
	userSmallPublicPlatoonRelation.Pid7 = standardSmallPublicPlatoonRelation.Pid7
	userSmallPublicPlatoonRelation.Pid8 = standardSmallPublicPlatoonRelation.Pid8
	userSmallPublicPlatoonRelation.Pid9 = standardSmallPublicPlatoonRelation.Pid9
	userSmallPublicPlatoonRelation.Position = 1
	userSmallPublicPlatoonRelation.Position1 = standardSmallPublicPlatoonRelation.Position1
	userSmallPublicPlatoonRelation.Position2 = standardSmallPublicPlatoonRelation.Position2
	userSmallPublicPlatoonRelation.Position3 = standardSmallPublicPlatoonRelation.Position3
	userSmallPublicPlatoonRelation.Position4 = standardSmallPublicPlatoonRelation.Position4
	userSmallPublicPlatoonRelation.Position5 = standardSmallPublicPlatoonRelation.Position5
	userSmallPublicPlatoonRelation.Position6 = standardSmallPublicPlatoonRelation.Position6
	userSmallPublicPlatoonRelation.Position7 = standardSmallPublicPlatoonRelation.Position7
	userSmallPublicPlatoonRelation.Position8 = standardSmallPublicPlatoonRelation.Position8
	userSmallPublicPlatoonRelation.Position9 = standardSmallPublicPlatoonRelation.Position9
	userSmallPublicPlatoonRelation.Level = 1
	userSmallPublicPlatoonRelation.Level1 = standardSmallPublicPlatoonRelation.Level1
	userSmallPublicPlatoonRelation.Level2 = standardSmallPublicPlatoonRelation.Level2
	userSmallPublicPlatoonRelation.Level3 = standardSmallPublicPlatoonRelation.Level3
	userSmallPublicPlatoonRelation.Level4 = standardSmallPublicPlatoonRelation.Level4
	userSmallPublicPlatoonRelation.Level5 = standardSmallPublicPlatoonRelation.Level5
	userSmallPublicPlatoonRelation.Level6 = standardSmallPublicPlatoonRelation.Level6
	userSmallPublicPlatoonRelation.Level7 = standardSmallPublicPlatoonRelation.Level7
	userSmallPublicPlatoonRelation.Level8 = standardSmallPublicPlatoonRelation.Level8
	userSmallPublicPlatoonRelation.Level9 = standardSmallPublicPlatoonRelation.Level9
	userSmallPublicPlatoonRelation.LevelTotal = standardSmallPublicPlatoonRelation.LevelTotal
	userSmallPublicPlatoonRelation.RecommendUid = recommendUid
	userSmallPublicPlatoonRelation.WaitForSettlementDate = now.AddDate(0, 0, userPublicPlatoonSetting.SettleDay).Format("2006-01-02")
	userSmallPublicPlatoonRelation.JoinAt = now
	userSmallPublicPlatoonRelation.CreateAt = now //
	userSmallPublicPlatoonRelation.UpdateAt = now
	userSmallPublicPlatoonRelation.HasSonNum = 0
	_, err = db.UserSmallPublicPlatoonRelationInsert(engine, &userSmallPublicPlatoonRelation)
	if err != nil {
		return model.UserSmallPublicPlatoonRelation{}, err
	}

	// 4、改变直属父级的 has_son_num 数量
	update, err := engine.Where("uid = ?", fatherUid).SetExpr("has_son_num", "has_son_num + 1").Update(new(model.UserSmallPublicPlatoonRelation))
	if err != nil {
		return userSmallPublicPlatoonRelation, err
	}
	if update == 0 {
		return userSmallPublicPlatoonRelation, errors.New("更新has_son_num数据出错")
	}
	return userSmallPublicPlatoonRelation, nil
}

// smallReverseDeductionPosition 逆向推导 position
func smallReverseDeductionPosition(calcPosition, levelFirstPosition, severalTimes int) (position int) {
	remainder := (calcPosition - 1) % severalTimes
	position = levelFirstPosition + remainder
	return
}

func smallReverseDeductionPositionByFather(fatherPosition, level, severalTimes, remainder int) (position int) {
	if fatherPosition == 0 {
		position = 0
		return
	}
	firstPosition := smallGetLevelForFirstPosition(level, severalTimes)
	endPosition := firstPosition + int(math.Pow(float64(severalTimes), float64(level-1))) - 1
	position = fatherPosition + (fatherPosition-firstPosition)*severalTimes + (endPosition - fatherPosition) + 1
	return
}

func smallFindSuitablePosition(engine *xorm.Engine, position *int, severalTimes float64, fuid, fatherLevel int, times *int) (standardSmallPublicPlatoonRelation md.StandardSmallPublicPlatoonRelation, fatherUid int, err error) {
	*times++
	positionName := "position" + zhios_order_relate_utils.IntToStr(*times)
	fatherName := "father_uid" + zhios_order_relate_utils.IntToStr(*times)
	firstSonPosition := smallSearchPositionFirstSonPosition(*position, int(severalTimes))
	var tempLevel float64
	smallMakeSearchLevel(&firstSonPosition, severalTimes, &tempLevel)
	firstSonLevel := int(tempLevel)
	endSonPosition := firstSonPosition + int(math.Pow(severalTimes, float64(firstSonLevel-fatherLevel))) - 1
	list, _, err := db.UserSmallPublicPlatoonRelationFindCountByPosition(engine, fuid, fatherName, positionName, int64(firstSonPosition), int64(endSonPosition))
	if err != nil {
		return standardSmallPublicPlatoonRelation, fatherUid, err
	}

	if list[0].HasSonNum == int(severalTimes) {
		//TODO::则证明该层直属下级无空位
		position = &firstSonPosition
		return smallFindSuitablePosition(engine, position, severalTimes, fuid, fatherLevel, times)
	} else if list[0].HasSonNum == 0 {
		fatherUid = list[0].Uid

		//TODO::新的一层
		standardSmallPublicPlatoonRelation.FatherUid1 = list[0].Uid
		standardSmallPublicPlatoonRelation.FatherUid2 = list[0].FatherUid1
		standardSmallPublicPlatoonRelation.FatherUid3 = list[0].FatherUid2
		standardSmallPublicPlatoonRelation.FatherUid4 = list[0].FatherUid3
		standardSmallPublicPlatoonRelation.FatherUid5 = list[0].FatherUid4
		standardSmallPublicPlatoonRelation.FatherUid6 = list[0].FatherUid5
		standardSmallPublicPlatoonRelation.FatherUid7 = list[0].FatherUid6
		standardSmallPublicPlatoonRelation.FatherUid8 = list[0].FatherUid7
		standardSmallPublicPlatoonRelation.FatherUid9 = list[0].FatherUid8

		standardSmallPublicPlatoonRelation.Pid1 = list[0].Position
		standardSmallPublicPlatoonRelation.Pid2 = list[0].Position1
		standardSmallPublicPlatoonRelation.Pid3 = list[0].Position2
		standardSmallPublicPlatoonRelation.Pid4 = list[0].Position3
		standardSmallPublicPlatoonRelation.Pid5 = list[0].Position4
		standardSmallPublicPlatoonRelation.Pid6 = list[0].Position5
		standardSmallPublicPlatoonRelation.Pid7 = list[0].Position6
		standardSmallPublicPlatoonRelation.Pid8 = list[0].Position7
		standardSmallPublicPlatoonRelation.Pid9 = list[0].Position8

		standardSmallPublicPlatoonRelation.Position1 = smallSearchPositionFirstSonPosition(list[0].Position, int(severalTimes))
		standardSmallPublicPlatoonRelation.Position2 = smallReverseDeductionPositionByFather(list[0].Position1, list[0].Level1, int(severalTimes), 0)
		standardSmallPublicPlatoonRelation.Position3 = smallReverseDeductionPositionByFather(list[0].Position2, list[0].Level2, int(severalTimes), 0)
		standardSmallPublicPlatoonRelation.Position4 = smallReverseDeductionPositionByFather(list[0].Position3, list[0].Level3, int(severalTimes), 0)
		standardSmallPublicPlatoonRelation.Position5 = smallReverseDeductionPositionByFather(list[0].Position4, list[0].Level4, int(severalTimes), 0)
		standardSmallPublicPlatoonRelation.Position6 = smallReverseDeductionPositionByFather(list[0].Position5, list[0].Level5, int(severalTimes), 0)
		standardSmallPublicPlatoonRelation.Position7 = smallReverseDeductionPositionByFather(list[0].Position6, list[0].Level6, int(severalTimes), 0)
		standardSmallPublicPlatoonRelation.Position8 = smallReverseDeductionPositionByFather(list[0].Position7, list[0].Level7, int(severalTimes), 0)
		standardSmallPublicPlatoonRelation.Position9 = smallReverseDeductionPositionByFather(list[0].Position8, list[0].Level8, int(severalTimes), 0)

		if list[0].Level1 == 0 {
			list[0].Level1--
		}
		if list[0].Level2 == 0 {
			list[0].Level2--
		}
		if list[0].Level3 == 0 {
			list[0].Level3--
		}
		if list[0].Level4 == 0 {
			list[0].Level4--
		}
		if list[0].Level5 == 0 {
			list[0].Level5--
		}
		if list[0].Level6 == 0 {
			list[0].Level6--
		}
		if list[0].Level7 == 0 {
			list[0].Level7--
		}
		if list[0].Level8 == 0 {
			list[0].Level8--
		}
		if list[0].Level9 == 0 {
			list[0].Level9--
		}
		standardSmallPublicPlatoonRelation.Level1 = list[0].Level + 1
		standardSmallPublicPlatoonRelation.Level2 = list[0].Level1 + 1
		standardSmallPublicPlatoonRelation.Level3 = list[0].Level2 + 1
		standardSmallPublicPlatoonRelation.Level4 = list[0].Level3 + 1
		standardSmallPublicPlatoonRelation.Level5 = list[0].Level4 + 1
		standardSmallPublicPlatoonRelation.Level6 = list[0].Level5 + 1
		standardSmallPublicPlatoonRelation.Level7 = list[0].Level6 + 1
		standardSmallPublicPlatoonRelation.Level8 = list[0].Level7 + 1
		standardSmallPublicPlatoonRelation.Level9 = list[0].Level8 + 1
		standardSmallPublicPlatoonRelation.LevelTotal = list[0].LevelTotal + 1
	} else {
		fatherUid = list[0].Uid

		_, _, _, _, getPositionName, _, _, _ := getPosition(list[0], *times+1)
		//userSmallPublicPlatoonRelations, err := db.UserSmallPublicPlatoonRelationFindByPid(engine, m.Position, m.Uid, "pid1", "father_uid1", "position1")

		userSmallPublicPlatoonRelations, err := db.UserSmallPublicPlatoonRelationFindByPid(engine, list[0].Uid, "father_uid1", getPositionName)

		if err != nil {
			return standardSmallPublicPlatoonRelation, fatherUid, err
		}

		if userSmallPublicPlatoonRelations[0].Position2 == 0 {
			userSmallPublicPlatoonRelations[0].Position2 = -1
		}
		if userSmallPublicPlatoonRelations[0].Position3 == 0 {
			standardSmallPublicPlatoonRelation.Position3 = -1
		}
		if userSmallPublicPlatoonRelations[0].Position4 == 0 {
			standardSmallPublicPlatoonRelation.Position4 = -1
		}
		if userSmallPublicPlatoonRelations[0].Position5 == 0 {
			standardSmallPublicPlatoonRelation.Position5 = -1
		}
		if userSmallPublicPlatoonRelations[0].Position6 == 0 {
			standardSmallPublicPlatoonRelation.Position6 = -1
		}
		if userSmallPublicPlatoonRelations[0].Position7 == 0 {
			standardSmallPublicPlatoonRelation.Position7 = -1
		}
		if userSmallPublicPlatoonRelations[0].Position8 == 0 {
			standardSmallPublicPlatoonRelation.Position8 = -1
		}
		if userSmallPublicPlatoonRelations[0].Position9 == 0 {
			standardSmallPublicPlatoonRelation.Position9 = -1
		}

		standardSmallPublicPlatoonRelation = md.StandardSmallPublicPlatoonRelation{
			FatherUid1: userSmallPublicPlatoonRelations[0].FatherUid1,
			FatherUid2: userSmallPublicPlatoonRelations[0].FatherUid2,
			FatherUid3: userSmallPublicPlatoonRelations[0].FatherUid3,
			FatherUid4: userSmallPublicPlatoonRelations[0].FatherUid4,
			FatherUid5: userSmallPublicPlatoonRelations[0].FatherUid5,
			FatherUid6: userSmallPublicPlatoonRelations[0].FatherUid6,
			FatherUid7: userSmallPublicPlatoonRelations[0].FatherUid7,
			FatherUid8: userSmallPublicPlatoonRelations[0].FatherUid8,
			FatherUid9: userSmallPublicPlatoonRelations[0].FatherUid9,
			Pid1:       userSmallPublicPlatoonRelations[0].Pid1,
			Pid2:       userSmallPublicPlatoonRelations[0].Pid2,
			Pid3:       userSmallPublicPlatoonRelations[0].Pid3,
			Pid4:       userSmallPublicPlatoonRelations[0].Pid4,
			Pid5:       userSmallPublicPlatoonRelations[0].Pid5,
			Pid6:       userSmallPublicPlatoonRelations[0].Pid6,
			Pid7:       userSmallPublicPlatoonRelations[0].Pid7,
			Pid8:       userSmallPublicPlatoonRelations[0].Pid8,
			Pid9:       userSmallPublicPlatoonRelations[0].Pid9,
			Position1:  userSmallPublicPlatoonRelations[0].Position1 + 1,
			Position2:  userSmallPublicPlatoonRelations[0].Position2 + 1,
			Position3:  userSmallPublicPlatoonRelations[0].Position3 + 1,
			Position4:  userSmallPublicPlatoonRelations[0].Position4 + 1,
			Position5:  userSmallPublicPlatoonRelations[0].Position5 + 1,
			Position6:  userSmallPublicPlatoonRelations[0].Position6 + 1,
			Position7:  userSmallPublicPlatoonRelations[0].Position7 + 1,
			Position8:  userSmallPublicPlatoonRelations[0].Position8 + 1,
			Position9:  userSmallPublicPlatoonRelations[0].Position9 + 1,
			Level1:     userSmallPublicPlatoonRelations[0].Level1,
			Level2:     userSmallPublicPlatoonRelations[0].Level2,
			Level3:     userSmallPublicPlatoonRelations[0].Level3,
			Level4:     userSmallPublicPlatoonRelations[0].Level4,
			Level5:     userSmallPublicPlatoonRelations[0].Level5,
			Level6:     userSmallPublicPlatoonRelations[0].Level6,
			Level7:     userSmallPublicPlatoonRelations[0].Level7,
			Level8:     userSmallPublicPlatoonRelations[0].Level8,
			Level9:     userSmallPublicPlatoonRelations[0].Level9,
			LevelTotal: userSmallPublicPlatoonRelations[0].LevelTotal,
		}
		return standardSmallPublicPlatoonRelation, fatherUid, nil
	}
	return
}

func getPosition(m model.UserSmallPublicPlatoonRelation, times int) (position, pid, level, fatherUid int, positionName, pidName, levelName, fatherUidName string) {
	if times == 1 {
		position = m.Position1
		positionName = "position1"
		pid = m.Pid1
		pidName = "pid1"
		level = m.Level1
		levelName = "level1"
		fatherUid = m.FatherUid1
		fatherUidName = "father_uid1"
	}
	if times == 2 {
		position = m.Position2
		positionName = "position2"
		pid = m.Pid2
		pidName = "pid2"
		level = m.Level2
		levelName = "level2"
		fatherUid = m.FatherUid2
		fatherUidName = "father_uid2"
	}
	if times == 3 {
		position = m.Position3
		positionName = "position3"
		pid = m.Pid3
		pidName = "pid3"
		level = m.Level3
		levelName = "level3"
		fatherUid = m.FatherUid3
		fatherUidName = "father_uid3"
	}
	if times == 4 {
		position = m.Position4
		positionName = "position4"
		pid = m.Pid4
		pidName = "pid4"
		level = m.Level4
		levelName = "level4"
		fatherUid = m.FatherUid4
		fatherUidName = "father_uid4"
	}
	if times == 5 {
		position = m.Position5
		positionName = "position5"
		pid = m.Pid5
		pidName = "pid5"
		level = m.Level5
		levelName = "level5"
		fatherUid = m.FatherUid5
		fatherUidName = "father_uid5"
	}
	if times == 6 {
		position = m.Position6
		positionName = "position6"
		pid = m.Pid6
		pidName = "pid6"
		level = m.Level6
		levelName = "level6"
		fatherUid = m.FatherUid6
		fatherUidName = "father_uid6"
	}
	if times == 7 {
		position = m.Position7
		positionName = "position7"
		pid = m.Pid7
		pidName = "pid7"
		level = m.Level7
		levelName = "level7"
		fatherUid = m.FatherUid7
		fatherUidName = "father_uid7"
	}
	if times == 8 {
		position = m.Position8
		positionName = "position8"
		pid = m.Pid8
		pidName = "pid8"
		level = m.Level8
		levelName = "level8"
		fatherUid = m.FatherUid8
		fatherUidName = "father_uid8"
	}
	if times == 9 {
		position = m.Position9
		positionName = "position9"
		pid = m.Pid9
		pidName = "pid9"
		level = m.Level9
		levelName = "level9"
		fatherUid = m.FatherUid9
		fatherUidName = "father_uid9"
	}
	return
}

// smallGetLevelForFirstPosition 返回当前等级的起始值
func smallGetLevelForFirstPosition(level, severalTimes int) (position int) {
	position = position + 1
	for n := 0; n <= (level - 2); n++ {
		position += int(math.Pow(float64(severalTimes), float64(n)))
	}
	return
}

//递归查找等级
func smallMakeSearchLevel(position *int, rows float64, times *float64) (level int) {
	difference := *position - int(math.Pow(rows, *times))
	*times++
	if difference <= 0 {
		return int(*times)
	} else {
		position = &difference
		return smallMakeSearchLevel(position, rows, times)
	}
}

//查找归属父级id
func smallMakeSearchPid(position int, row int) (pid int) {
	divisionValue := (position - 1) / row
	if divisionValue == 0 {
		pid = 1
		return
	} else {
		if (divisionValue*row + 1) == position {
			pid = divisionValue
			return
		} else {
			pid = divisionValue + 1
			return
		}
	}
}

//查找当前位置下的第一个子集位置
func smallSearchPositionFirstSonPosition(position int, times int) (sonPosition int) {
	sonPosition = (position * times) - (times - 2)
	return
}

//查找当前位位置相当于父级的等级
func smallSearchPositionSonForLevel(fatherUid string, fatherPosition int) (level int) {
	fatherUids := strings.Split(fatherUid, "-")
	for key, item := range fatherUids {
		if item == strconv.Itoa(fatherPosition) {
			level = key + 1
			break
		}
	}
	return
}

// SmallFindWaitForDealUsers 查询待处理的用户
func SmallFindWaitForDealUsers(engine *xorm.Engine, page, pageSize int) (err error, resp []int) {
	now := time.Now().Format("2006-01-02")
	lists, err := db.UserSmallPublicPlatoonRelationFindByParamsByPage(engine, map[string]interface{}{
		"key":   "wait_for_settlement_date",
		"value": now,
	}, page, pageSize)
	if err != nil {
		return
	}
	for _, list := range *lists {
		resp = append(resp, list.Uid)
	}
	return
}

// SmallUpdateWaitForSettlementDate 改变 `wait_for_settlement_date` 待结算时间
func SmallUpdateWaitForSettlementDate(engine *xorm.Engine, userIds []string) (err error) {
	//查找 `user_public_platoon_setting` 基础设置
	userPublicPlatoonSetting, err := db.UserPublicPlatoonSettingGetOneByParams(engine, map[string]interface{}{
		"key":   "is_open",
		"value": 1,
	})
	if err != nil {
		return err
	}
	settleDay := 30
	if userPublicPlatoonSetting != nil && userPublicPlatoonSetting.SettleDay == 0 {
		settleDay = 30
	} else {
		settleDay = userPublicPlatoonSetting.SettleDay
	}
	//Todo:: 将 user_public_platoon_relation 中 wait_for_settlement_date 设置为 30天后
	sql := "update user_small_public_platoon_relation set wait_for_settlement_date = ? where uid in (" + strings.Join(userIds, ",") + ")"
	waitForSettlementDate := time.Now().AddDate(0, 0, settleDay).Format("2006-01-02")
	_, err = engine.Exec(sql, waitForSettlementDate)
	if err != nil {
		return
	}
	return
}

// SmallDealCommonWealthReward 处理共富奖励
func SmallDealCommonWealthReward(engine *xorm.Engine, uid int, isCompleteReward bool) (err error, resp []map[string]string) {
	session := engine.NewSession()
	defer func() {
		session.Close()
		if err := recover(); err != nil {
			_ = zhios_order_relate_logx.Error(err)
		}
	}()
	session.Begin()

	//1、查询出 `user_public_platoon_amount` 中相关记录
	params, err := db.UserPublicPlatoonAmountFindByParams(engine, map[string]interface{}{
		"key":   "uid",
		"value": uid,
	})
	if err != nil {
		_ = session.Rollback()
		return
	}

	//2、完成共富奖励(插入 user_public_platoon_settlement_records 记录) && 构造返回数据
	var userPublicPlatoonSettlementRecords []*model.UserPublicPlatoonSettlementRecords
	var userPublicPlatoonIncomeRecords []*model.UserPublicPlatoonIncomeRecords

	now := time.Now()
	for _, param := range *params {
		var userPublicPlatoonSettlementRecord = model.UserPublicPlatoonSettlementRecords{
			Uid:      param.Uid,
			CoinId:   param.CoinId,
			Amount:   param.Amount,
			Title:    "结算共富奖励",
			Date:     now.AddDate(0, 0, 30).Format("2006-01-02"),
			Type:     2,
			CreateAt: now,
			UpdateAt: now,
		}
		//流水表
		var userPublicPlatoonIncomeRecord = model.UserPublicPlatoonIncomeRecords{
			Uid:      param.Uid,
			CoinId:   param.CoinId,
			Amount:   param.Amount,
			Date:     now.AddDate(0, 0, 30).Format("2006-01-02"),
			CreateAt: now,
			UpdateAt: now,
		}
		if isCompleteReward {
			userPublicPlatoonIncomeRecord.Title = "共富收益转入余额"
			userPublicPlatoonIncomeRecord.Kind = 1
			userPublicPlatoonSettlementRecord.Kind = 1
			resp = append(resp, map[string]string{
				zhios_order_relate_utils.AnyToString(param.CoinId): param.Amount,
			})
		} else {
			userPublicPlatoonIncomeRecord.Title = "共富收益清零"
			userPublicPlatoonIncomeRecord.Kind = 2
			userPublicPlatoonSettlementRecord.Kind = 2
		}
		if zhios_order_relate_utils.StrToFloat64(userPublicPlatoonSettlementRecord.Amount) > 0 {
			userPublicPlatoonSettlementRecords = append(userPublicPlatoonSettlementRecords, &userPublicPlatoonSettlementRecord)
		}
		if zhios_order_relate_utils.StrToFloat64(userPublicPlatoonIncomeRecord.Amount) > 0 {
			userPublicPlatoonIncomeRecords = append(userPublicPlatoonIncomeRecords, &userPublicPlatoonIncomeRecord)
		}
	}
	affected, err := db.BatchAddUserPublicPlatoonSettlementRecordss(session, userPublicPlatoonSettlementRecords)
	if err != nil {
		_ = session.Rollback()
		return
	}
	if affected == 0 {
		err = errors.New("插入 user_public_platoon_settlement_records 记录失败")
		_ = session.Rollback()
		return
	}
	affectedIncome, errIncome := db.BatchAddUserPublicPlatoonIncomeRecordss(session, userPublicPlatoonIncomeRecords)
	if errIncome != nil {
		_ = session.Rollback()
		return
	}
	if affectedIncome == 0 {
		err = errors.New("插入 user_public_platoon_settlement_records 记录失败")
		_ = session.Rollback()
		return
	}

	//3、将 user_public_platoon_amount 相关记录的 amount 置 0
	sql := "update user_public_platoon_amount set amount = ? where uid = ?"
	_, err = session.Exec(sql, 0, uid)
	if err != nil {
		_ = session.Rollback()
		return
	}
	err = session.Commit()
	return
}

// SmallDealCommonWealthPunish 处理共富处罚
func SmallDealCommonWealthPunish(engine *xorm.Engine, uid int, reason string) (err error, resp []map[string]string) {
	session := engine.NewSession()
	defer func() {
		session.Close()
		if err := recover(); err != nil {
			_ = zhios_order_relate_logx.Error(err)
		}
	}()
	session.Begin()

	//1、查找 `user_public_platoon_setting` 基础设置
	userPublicPlatoonSetting, err := db.UserPublicPlatoonSettingGetOneByParams(engine, map[string]interface{}{
		"key":   "is_open",
		"value": 1,
	})
	if err != nil {
		_ = session.Rollback()
		return
	}

	//2、查询出 `user_small_public_platoon_relation` 中相关记录 && 将该记录的uid置为 -1
	params, err := db.UserSmallPublicPlatoonRelationGetOneByParams(engine, map[string]interface{}{
		"key":   "uid",
		"value": uid,
	})
	if err != nil {
		_ = session.Rollback()
		return
	}
	if params == nil {
		fmt.Println("未查询到公排关系记录!!!!!!!", uid)
		_ = session.Rollback()
	}

	//TODO::判断是否为推荐用户
	if params.RecommendUid == 0 {
		params.Uid = params.Uid - int(time.Now().Unix())
	} else {
		params.Uid = params.Uid - int(time.Now().Unix())
	}

	for n := 1; n <= 9; n++ {
		str := "father_uid" + strconv.Itoa(n)
		sql := fmt.Sprintf("UPDATE `user_small_public_platoon_relation` SET %s=%s where %s=%s", str, strconv.Itoa(params.Uid), str, strconv.Itoa(uid))
		fmt.Println(">>>>>>>sql>>>>>>>", sql)
		_, err = session.Exec(sql)
		if err != nil {
			_ = session.Rollback()
			return
		}
	}

	updateAffected, err := db.UserSmallPublicPlatoonRelationUpdate(session, params.Id, params)
	if err != nil {
		_ = session.Rollback()
		return
	}
	if updateAffected == 0 {
		err = errors.New("更新 user_public_platoon_relation 记录失败")
		_ = session.Rollback()
		return
	}

	//3、新增一条 `user_public_platoon_relation` 记录
	params.Uid = uid
	res, err := smallPublicPlatoon(engine, params.Uid, params.RecommendUid, *userPublicPlatoonSetting)
	if err != nil {
		_ = session.Rollback()
		return
	}

	//4、新增一条 `user_public_platoon_system_punish_records` 记录
	now := time.Now()
	insertAffected, err := db.UserPublicPlatoonSystemPunishRecordsInsert(session, &model.UserPublicPlatoonSystemPunishRecords{
		Uid:        params.Uid,
		OldPostion: params.Position,
		NewPostion: res.Position,
		Date:       now.AddDate(0, 0, 30).Format("2006-01-02"),
		Title:      "共富收益-系统处罚记录",
		Reason:     reason,
		Type:       2,
		CreateAt:   now,
		UpdateAt:   now,
	})
	if err != nil {
		_ = session.Rollback()
		return
	}
	if insertAffected == 0 {
		err = errors.New("新增 user_public_platoon_system_punish_records 记录失败")
		_ = session.Rollback()
		return
	}

	err = session.Commit()
	return
}
